searchData={"items":[{"type":"module","title":"edb_app","doc":"edb public API","ref":"edb_app.html"},{"type":"function","title":"edb_app.start/2","doc":"","ref":"edb_app.html#start/2"},{"type":"function","title":"edb_app.stop/1","doc":"","ref":"edb_app.html#stop/1"},{"type":"module","title":"edb_dap","doc":"Support for the DAP Protocol\n\nThe Debug Adapter Protocol (DAP) defines the abstract protocol\nused between a development tool (e.g. IDE or editor) and a\ndebugger, using JSON-RPC as the underlying transport protocol.\n\nThis module implements the types and functions required to\nencode and decode messages to and from the DAP protocol.\n\nFor the full specification, please refer to:\n\nhttps://microsoft.github.io/debug-adapter-protocol/specification","ref":"edb_dap.html"},{"type":"function","title":"edb_dap.decode_frames/1","doc":"","ref":"edb_dap.html#decode_frames/1"},{"type":"function","title":"edb_dap.encode_frame/1","doc":"","ref":"edb_dap.html#encode_frame/1"},{"type":"function","title":"edb_dap.frame/1","doc":"","ref":"edb_dap.html#frame/1"},{"type":"function","title":"edb_dap.to_binary/1","doc":"","ref":"edb_dap.html#to_binary/1"},{"type":"function","title":"edb_dap.unframe/1","doc":"","ref":"edb_dap.html#unframe/1"},{"type":"type","title":"edb_dap.arguments/0","doc":"","ref":"edb_dap.html#t:arguments/0"},{"type":"type","title":"edb_dap.body/0","doc":"","ref":"edb_dap.html#t:body/0"},{"type":"type","title":"edb_dap.checksum/0","doc":"","ref":"edb_dap.html#t:checksum/0"},{"type":"type","title":"edb_dap.checksumAlgorithm/0","doc":"","ref":"edb_dap.html#t:checksumAlgorithm/0"},{"type":"type","title":"edb_dap.command/0","doc":"","ref":"edb_dap.html#t:command/0"},{"type":"type","title":"edb_dap.error_response/0","doc":"","ref":"edb_dap.html#t:error_response/0"},{"type":"type","title":"edb_dap.event/0","doc":"","ref":"edb_dap.html#t:event/0"},{"type":"type","title":"edb_dap.event_type/0","doc":"","ref":"edb_dap.html#t:event_type/0"},{"type":"opaque","title":"edb_dap.frame/0","doc":"","ref":"edb_dap.html#t:frame/0"},{"type":"type","title":"edb_dap.message/0","doc":"","ref":"edb_dap.html#t:message/0"},{"type":"type","title":"edb_dap.protocol_message/0","doc":"","ref":"edb_dap.html#t:protocol_message/0"},{"type":"type","title":"edb_dap.protocol_message_type/0","doc":"","ref":"edb_dap.html#t:protocol_message_type/0"},{"type":"type","title":"edb_dap.request/0","doc":"","ref":"edb_dap.html#t:request/0"},{"type":"type","title":"edb_dap.response/0","doc":"","ref":"edb_dap.html#t:response/0"},{"type":"type","title":"edb_dap.seq/0","doc":"","ref":"edb_dap.html#t:seq/0"},{"type":"type","title":"edb_dap.source/0","doc":"","ref":"edb_dap.html#t:source/0"},{"type":"type","title":"edb_dap.stepping_granularity/0","doc":"","ref":"edb_dap.html#t:stepping_granularity/0"},{"type":"type","title":"edb_dap.thread_id/0","doc":"","ref":"edb_dap.html#t:thread_id/0"},{"type":"module","title":"edb_dap_event","doc":"DAP Events","ref":"edb_dap_event.html"},{"type":"function","title":"edb_dap_event.exited/1","doc":"","ref":"edb_dap_event.html#exited/1"},{"type":"function","title":"edb_dap_event.initialized/0","doc":"","ref":"edb_dap_event.html#initialized/0"},{"type":"function","title":"edb_dap_event.stopped/1","doc":"","ref":"edb_dap_event.html#stopped/1"},{"type":"function","title":"edb_dap_event.terminated/0","doc":"","ref":"edb_dap_event.html#terminated/0"},{"type":"type","title":"edb_dap_event.event/0","doc":"","ref":"edb_dap_event.html#t:event/0"},{"type":"type","title":"edb_dap_event.event/1","doc":"","ref":"edb_dap_event.html#t:event/1"},{"type":"type","title":"edb_dap_event.exited_body/0","doc":"","ref":"edb_dap_event.html#t:exited_body/0"},{"type":"type","title":"edb_dap_event.stopped_body/0","doc":"","ref":"edb_dap_event.html#t:stopped_body/0"},{"type":"type","title":"edb_dap_event.terminated_body/0","doc":"","ref":"edb_dap_event.html#t:terminated_body/0"},{"type":"module","title":"edb_dap_id_mappings","doc":"An mapper of IDs for the debug adapter\n\nThe DAP protocol expects numeric ids for threads, frames, scopes, etc. These ids\nare represented as number() in the JSON specification, and are expected to fit\nin a 64-bit float. Some ids like thread_ids are expected to be unique across the\ndebugging session, while others (frame-ids, etc), need be unique only between\npauses. The specification recommends adapters to reset them on `continue` requests.\nFor more details see https://microsoft.github.io/debug-adapter-protocol/overview\n\nThis module implements the mapping fo PIDs to thread-ids, etc, generically.","ref":"edb_dap_id_mappings.html"},{"type":"function","title":"edb_dap_id_mappings.frame_id_to_pid_frame/1","doc":"","ref":"edb_dap_id_mappings.html#frame_id_to_pid_frame/1"},{"type":"function","title":"edb_dap_id_mappings.frame_scope_or_structured_to_var_reference/1","doc":"","ref":"edb_dap_id_mappings.html#frame_scope_or_structured_to_var_reference/1"},{"type":"function","title":"edb_dap_id_mappings.handle_call/3","doc":"","ref":"edb_dap_id_mappings.html#handle_call/3"},{"type":"function","title":"edb_dap_id_mappings.handle_cast/2","doc":"","ref":"edb_dap_id_mappings.html#handle_cast/2"},{"type":"function","title":"edb_dap_id_mappings.handle_info/2","doc":"","ref":"edb_dap_id_mappings.html#handle_info/2"},{"type":"function","title":"edb_dap_id_mappings.init/1","doc":"","ref":"edb_dap_id_mappings.html#init/1"},{"type":"function","title":"edb_dap_id_mappings.pid_frame_to_frame_id/1","doc":"","ref":"edb_dap_id_mappings.html#pid_frame_to_frame_id/1"},{"type":"function","title":"edb_dap_id_mappings.pid_to_thread_id/1","doc":"","ref":"edb_dap_id_mappings.html#pid_to_thread_id/1"},{"type":"function","title":"edb_dap_id_mappings.pids_to_thread_ids/1","doc":"","ref":"edb_dap_id_mappings.html#pids_to_thread_ids/1"},{"type":"function","title":"edb_dap_id_mappings.reset/0","doc":"","ref":"edb_dap_id_mappings.html#reset/0"},{"type":"function","title":"edb_dap_id_mappings.start_link_frame_ids_server/0","doc":"","ref":"edb_dap_id_mappings.html#start_link_frame_ids_server/0"},{"type":"function","title":"edb_dap_id_mappings.start_link_thread_ids_server/0","doc":"","ref":"edb_dap_id_mappings.html#start_link_thread_ids_server/0"},{"type":"function","title":"edb_dap_id_mappings.start_link_var_reference_ids_server/0","doc":"","ref":"edb_dap_id_mappings.html#start_link_var_reference_ids_server/0"},{"type":"function","title":"edb_dap_id_mappings.thread_id_to_pid/1","doc":"","ref":"edb_dap_id_mappings.html#thread_id_to_pid/1"},{"type":"function","title":"edb_dap_id_mappings.var_reference_to_frame_scope_or_structured/1","doc":"","ref":"edb_dap_id_mappings.html#var_reference_to_frame_scope_or_structured/1"},{"type":"type","title":"edb_dap_id_mappings.frame_scope/0","doc":"","ref":"edb_dap_id_mappings.html#t:frame_scope/0"},{"type":"type","title":"edb_dap_id_mappings.frame_scope_or_structured/0","doc":"","ref":"edb_dap_id_mappings.html#t:frame_scope_or_structured/0"},{"type":"type","title":"edb_dap_id_mappings.id/0","doc":"An integer that fits in a 64-bit float.\nThis is the requirement the DAP spec puts on ids.","ref":"edb_dap_id_mappings.html#t:id/0"},{"type":"type","title":"edb_dap_id_mappings.id_mapping/1","doc":"","ref":"edb_dap_id_mappings.html#t:id_mapping/1"},{"type":"type","title":"edb_dap_id_mappings.pid_frame/0","doc":"","ref":"edb_dap_id_mappings.html#t:pid_frame/0"},{"type":"type","title":"edb_dap_id_mappings.scope/0","doc":"","ref":"edb_dap_id_mappings.html#t:scope/0"},{"type":"type","title":"edb_dap_id_mappings.state/1","doc":"","ref":"edb_dap_id_mappings.html#t:state/1"},{"type":"type","title":"edb_dap_id_mappings.structured/0","doc":"","ref":"edb_dap_id_mappings.html#t:structured/0"},{"type":"type","title":"edb_dap_id_mappings.validator/1","doc":"","ref":"edb_dap_id_mappings.html#t:validator/1"},{"type":"module","title":"edb_dap_internal_events","doc":"Handle events coming from the debugger.","ref":"edb_dap_internal_events.html"},{"type":"function","title":"edb_dap_internal_events.handle_edb_event/2","doc":"","ref":"edb_dap_internal_events.html#handle_edb_event/2"},{"type":"function","title":"edb_dap_internal_events.handle_reverse_attach_result/2","doc":"","ref":"edb_dap_internal_events.html#handle_reverse_attach_result/2"},{"type":"type","title":"edb_dap_internal_events.reaction/0","doc":"","ref":"edb_dap_internal_events.html#t:reaction/0"},{"type":"type","title":"edb_dap_internal_events.reverse_attach_result/0","doc":"","ref":"edb_dap_internal_events.html#t:reverse_attach_result/0"},{"type":"module","title":"edb_dap_parse","doc":"Support for parsing of request arguments, etc","ref":"edb_dap_parse.html"},{"type":"function","title":"edb_dap_parse.atom/0","doc":"","ref":"edb_dap_parse.html#atom/0"},{"type":"function","title":"edb_dap_parse.atom/1","doc":"","ref":"edb_dap_parse.html#atom/1"},{"type":"function","title":"edb_dap_parse.atoms/1","doc":"","ref":"edb_dap_parse.html#atoms/1"},{"type":"function","title":"edb_dap_parse.binary/0","doc":"","ref":"edb_dap_parse.html#binary/0"},{"type":"function","title":"edb_dap_parse.boolean/0","doc":"","ref":"edb_dap_parse.html#boolean/0"},{"type":"function","title":"edb_dap_parse.choice/1","doc":"","ref":"edb_dap_parse.html#choice/1"},{"type":"function","title":"edb_dap_parse.empty_list/0","doc":"","ref":"edb_dap_parse.html#empty_list/0"},{"type":"function","title":"edb_dap_parse.list/1","doc":"","ref":"edb_dap_parse.html#list/1"},{"type":"function","title":"edb_dap_parse.map/2","doc":"","ref":"edb_dap_parse.html#map/2"},{"type":"function","title":"edb_dap_parse.non_neg_integer/0","doc":"","ref":"edb_dap_parse.html#non_neg_integer/0"},{"type":"function","title":"edb_dap_parse.nonempty_list/1","doc":"","ref":"edb_dap_parse.html#nonempty_list/1"},{"type":"function","title":"edb_dap_parse.null/0","doc":"","ref":"edb_dap_parse.html#null/0"},{"type":"function","title":"edb_dap_parse.number/0","doc":"","ref":"edb_dap_parse.html#number/0"},{"type":"function","title":"edb_dap_parse.parse/3","doc":"","ref":"edb_dap_parse.html#parse/3"},{"type":"function","title":"edb_dap_parse.template/1","doc":"","ref":"edb_dap_parse.html#template/1"},{"type":"type","title":"edb_dap_parse.field_parser/0","doc":"","ref":"edb_dap_parse.html#t:field_parser/0"},{"type":"type","title":"edb_dap_parse.parser/1","doc":"","ref":"edb_dap_parse.html#t:parser/1"},{"type":"type","title":"edb_dap_parse.template/0","doc":"","ref":"edb_dap_parse.html#t:template/0"},{"type":"type","title":"edb_dap_parse.value_parser/0","doc":"","ref":"edb_dap_parse.html#t:value_parser/0"},{"type":"behaviour","title":"edb_dap_request","doc":"Behaviour for handling client requests","ref":"edb_dap_request.html"},{"type":"function","title":"edb_dap_request.abort/1","doc":"","ref":"edb_dap_request.html#abort/1"},{"type":"function","title":"edb_dap_request.dispatch/2","doc":"","ref":"edb_dap_request.html#dispatch/2"},{"type":"callback","title":"edb_dap_request.handle/2","doc":"","ref":"edb_dap_request.html#c:handle/2"},{"type":"function","title":"edb_dap_request.not_paused/1","doc":"","ref":"edb_dap_request.html#not_paused/1"},{"type":"callback","title":"edb_dap_request.parse_arguments/1","doc":"","ref":"edb_dap_request.html#c:parse_arguments/1"},{"type":"function","title":"edb_dap_request.parse_empty_arguments/1","doc":"","ref":"edb_dap_request.html#parse_empty_arguments/1"},{"type":"function","title":"edb_dap_request.precondition_violation/1","doc":"","ref":"edb_dap_request.html#precondition_violation/1"},{"type":"function","title":"edb_dap_request.success/0","doc":"","ref":"edb_dap_request.html#success/0"},{"type":"function","title":"edb_dap_request.success/1","doc":"","ref":"edb_dap_request.html#success/1"},{"type":"function","title":"edb_dap_request.thread_id_to_pid/1","doc":"","ref":"edb_dap_request.html#thread_id_to_pid/1"},{"type":"function","title":"edb_dap_request.unexpected_request/0","doc":"","ref":"edb_dap_request.html#unexpected_request/0"},{"type":"function","title":"edb_dap_request.unknown_resource/2","doc":"","ref":"edb_dap_request.html#unknown_resource/2"},{"type":"function","title":"edb_dap_request.unsupported/1","doc":"","ref":"edb_dap_request.html#unsupported/1"},{"type":"type","title":"edb_dap_request.error_reaction/0","doc":"","ref":"edb_dap_request.html#t:error_reaction/0"},{"type":"type","title":"edb_dap_request.reaction/0","doc":"","ref":"edb_dap_request.html#t:reaction/0"},{"type":"type","title":"edb_dap_request.reaction/1","doc":"","ref":"edb_dap_request.html#t:reaction/1"},{"type":"type","title":"edb_dap_request.resource/0","doc":"","ref":"edb_dap_request.html#t:resource/0"},{"type":"type","title":"edb_dap_request.response/1","doc":"","ref":"edb_dap_request.html#t:response/1"},{"type":"module","title":"edb_dap_request_attach","doc":null,"ref":"edb_dap_request_attach.html"},{"type":"function","title":"edb_dap_request_attach.handle/2","doc":null,"ref":"edb_dap_request_attach.html#handle/2"},{"type":"function","title":"edb_dap_request_attach.handle_bootstrap_failure/1","doc":null,"ref":"edb_dap_request_attach.html#handle_bootstrap_failure/1"},{"type":"function","title":"edb_dap_request_attach.parse_arguments/1","doc":null,"ref":"edb_dap_request_attach.html#parse_arguments/1"},{"type":"type","title":"edb_dap_request_attach.arguments/0","doc":null,"ref":"edb_dap_request_attach.html#t:arguments/0"},{"type":"type","title":"edb_dap_request_attach.config/0","doc":null,"ref":"edb_dap_request_attach.html#t:config/0"},{"type":"module","title":"edb_dap_request_configuration_done","doc":null,"ref":"edb_dap_request_configuration_done.html"},{"type":"function","title":"edb_dap_request_configuration_done.handle/2","doc":null,"ref":"edb_dap_request_configuration_done.html#handle/2"},{"type":"function","title":"edb_dap_request_configuration_done.parse_arguments/1","doc":null,"ref":"edb_dap_request_configuration_done.html#parse_arguments/1"},{"type":"type","title":"edb_dap_request_configuration_done.arguments/0","doc":null,"ref":"edb_dap_request_configuration_done.html#t:arguments/0"},{"type":"module","title":"edb_dap_request_continue","doc":null,"ref":"edb_dap_request_continue.html"},{"type":"function","title":"edb_dap_request_continue.handle/2","doc":null,"ref":"edb_dap_request_continue.html#handle/2"},{"type":"function","title":"edb_dap_request_continue.parse_arguments/1","doc":null,"ref":"edb_dap_request_continue.html#parse_arguments/1"},{"type":"type","title":"edb_dap_request_continue.arguments/0","doc":null,"ref":"edb_dap_request_continue.html#t:arguments/0"},{"type":"type","title":"edb_dap_request_continue.response_body/0","doc":null,"ref":"edb_dap_request_continue.html#t:response_body/0"},{"type":"module","title":"edb_dap_request_disconnect","doc":null,"ref":"edb_dap_request_disconnect.html"},{"type":"function","title":"edb_dap_request_disconnect.handle/2","doc":null,"ref":"edb_dap_request_disconnect.html#handle/2"},{"type":"function","title":"edb_dap_request_disconnect.parse_arguments/1","doc":null,"ref":"edb_dap_request_disconnect.html#parse_arguments/1"},{"type":"type","title":"edb_dap_request_disconnect.arguments/0","doc":null,"ref":"edb_dap_request_disconnect.html#t:arguments/0"},{"type":"type","title":"edb_dap_request_disconnect.victims/0","doc":null,"ref":"edb_dap_request_disconnect.html#t:victims/0"},{"type":"module","title":"edb_dap_request_initialize","doc":null,"ref":"edb_dap_request_initialize.html"},{"type":"function","title":"edb_dap_request_initialize.handle/2","doc":null,"ref":"edb_dap_request_initialize.html#handle/2"},{"type":"function","title":"edb_dap_request_initialize.parse_arguments/1","doc":null,"ref":"edb_dap_request_initialize.html#parse_arguments/1"},{"type":"type","title":"edb_dap_request_initialize.arguments/0","doc":null,"ref":"edb_dap_request_initialize.html#t:arguments/0"},{"type":"type","title":"edb_dap_request_initialize.breakpointMode/0","doc":null,"ref":"edb_dap_request_initialize.html#t:breakpointMode/0"},{"type":"type","title":"edb_dap_request_initialize.breakpointModeApplicability/0","doc":null,"ref":"edb_dap_request_initialize.html#t:breakpointModeApplicability/0"},{"type":"type","title":"edb_dap_request_initialize.capabilities/0","doc":null,"ref":"edb_dap_request_initialize.html#t:capabilities/0"},{"type":"type","title":"edb_dap_request_initialize.columnDescriptor/0","doc":null,"ref":"edb_dap_request_initialize.html#t:columnDescriptor/0"},{"type":"type","title":"edb_dap_request_initialize.exceptionBreakpointsFilter/0","doc":null,"ref":"edb_dap_request_initialize.html#t:exceptionBreakpointsFilter/0"},{"type":"module","title":"edb_dap_request_launch","doc":null,"ref":"edb_dap_request_launch.html"},{"type":"function","title":"edb_dap_request_launch.handle/2","doc":null,"ref":"edb_dap_request_launch.html#handle/2"},{"type":"function","title":"edb_dap_request_launch.parse_arguments/1","doc":null,"ref":"edb_dap_request_launch.html#parse_arguments/1"},{"type":"type","title":"edb_dap_request_launch.arguments/0","doc":null,"ref":"edb_dap_request_launch.html#t:arguments/0"},{"type":"type","title":"edb_dap_request_launch.config/0","doc":null,"ref":"edb_dap_request_launch.html#t:config/0"},{"type":"type","title":"edb_dap_request_launch.run_in_terminal/0","doc":null,"ref":"edb_dap_request_launch.html#t:run_in_terminal/0"},{"type":"module","title":"edb_dap_request_next","doc":null,"ref":"edb_dap_request_next.html"},{"type":"function","title":"edb_dap_request_next.handle/2","doc":null,"ref":"edb_dap_request_next.html#handle/2"},{"type":"function","title":"edb_dap_request_next.parse_arguments/1","doc":null,"ref":"edb_dap_request_next.html#parse_arguments/1"},{"type":"function","title":"edb_dap_request_next.parse_stepping_granularity/0","doc":null,"ref":"edb_dap_request_next.html#parse_stepping_granularity/0"},{"type":"function","title":"edb_dap_request_next.stepper/3","doc":null,"ref":"edb_dap_request_next.html#stepper/3"},{"type":"type","title":"edb_dap_request_next.arguments/0","doc":null,"ref":"edb_dap_request_next.html#t:arguments/0"},{"type":"module","title":"edb_dap_request_pause","doc":null,"ref":"edb_dap_request_pause.html"},{"type":"function","title":"edb_dap_request_pause.handle/2","doc":null,"ref":"edb_dap_request_pause.html#handle/2"},{"type":"function","title":"edb_dap_request_pause.parse_arguments/1","doc":null,"ref":"edb_dap_request_pause.html#parse_arguments/1"},{"type":"type","title":"edb_dap_request_pause.arguments/0","doc":null,"ref":"edb_dap_request_pause.html#t:arguments/0"},{"type":"module","title":"edb_dap_request_scopes","doc":null,"ref":"edb_dap_request_scopes.html"},{"type":"function","title":"edb_dap_request_scopes.handle/2","doc":null,"ref":"edb_dap_request_scopes.html#handle/2"},{"type":"function","title":"edb_dap_request_scopes.parse_arguments/1","doc":null,"ref":"edb_dap_request_scopes.html#parse_arguments/1"},{"type":"type","title":"edb_dap_request_scopes.arguments/0","doc":null,"ref":"edb_dap_request_scopes.html#t:arguments/0"},{"type":"type","title":"edb_dap_request_scopes.response_body/0","doc":null,"ref":"edb_dap_request_scopes.html#t:response_body/0"},{"type":"type","title":"edb_dap_request_scopes.scope/0","doc":null,"ref":"edb_dap_request_scopes.html#t:scope/0"},{"type":"module","title":"edb_dap_request_set_breakpoints","doc":null,"ref":"edb_dap_request_set_breakpoints.html"},{"type":"function","title":"edb_dap_request_set_breakpoints.handle/2","doc":null,"ref":"edb_dap_request_set_breakpoints.html#handle/2"},{"type":"function","title":"edb_dap_request_set_breakpoints.parse_arguments/1","doc":null,"ref":"edb_dap_request_set_breakpoints.html#parse_arguments/1"},{"type":"type","title":"edb_dap_request_set_breakpoints.arguments/0","doc":null,"ref":"edb_dap_request_set_breakpoints.html#t:arguments/0"},{"type":"type","title":"edb_dap_request_set_breakpoints.breakpoint/0","doc":null,"ref":"edb_dap_request_set_breakpoints.html#t:breakpoint/0"},{"type":"type","title":"edb_dap_request_set_breakpoints.response/0","doc":null,"ref":"edb_dap_request_set_breakpoints.html#t:response/0"},{"type":"type","title":"edb_dap_request_set_breakpoints.sourceBreakpoint/0","doc":null,"ref":"edb_dap_request_set_breakpoints.html#t:sourceBreakpoint/0"},{"type":"module","title":"edb_dap_request_set_exception_breakpoints","doc":null,"ref":"edb_dap_request_set_exception_breakpoints.html"},{"type":"function","title":"edb_dap_request_set_exception_breakpoints.handle/2","doc":null,"ref":"edb_dap_request_set_exception_breakpoints.html#handle/2"},{"type":"function","title":"edb_dap_request_set_exception_breakpoints.parse_arguments/1","doc":null,"ref":"edb_dap_request_set_exception_breakpoints.html#parse_arguments/1"},{"type":"type","title":"edb_dap_request_set_exception_breakpoints.arguments/0","doc":null,"ref":"edb_dap_request_set_exception_breakpoints.html#t:arguments/0"},{"type":"type","title":"edb_dap_request_set_exception_breakpoints.exception_break_mode/0","doc":null,"ref":"edb_dap_request_set_exception_breakpoints.html#t:exception_break_mode/0"},{"type":"type","title":"edb_dap_request_set_exception_breakpoints.exception_filter_options/0","doc":null,"ref":"edb_dap_request_set_exception_breakpoints.html#t:exception_filter_options/0"},{"type":"type","title":"edb_dap_request_set_exception_breakpoints.exception_options/0","doc":null,"ref":"edb_dap_request_set_exception_breakpoints.html#t:exception_options/0"},{"type":"type","title":"edb_dap_request_set_exception_breakpoints.exception_path_segment/0","doc":null,"ref":"edb_dap_request_set_exception_breakpoints.html#t:exception_path_segment/0"},{"type":"type","title":"edb_dap_request_set_exception_breakpoints.response/0","doc":null,"ref":"edb_dap_request_set_exception_breakpoints.html#t:response/0"},{"type":"module","title":"edb_dap_request_stack_trace","doc":null,"ref":"edb_dap_request_stack_trace.html"},{"type":"function","title":"edb_dap_request_stack_trace.handle/2","doc":null,"ref":"edb_dap_request_stack_trace.html#handle/2"},{"type":"function","title":"edb_dap_request_stack_trace.parse_arguments/1","doc":null,"ref":"edb_dap_request_stack_trace.html#parse_arguments/1"},{"type":"type","title":"edb_dap_request_stack_trace.arguments/0","doc":null,"ref":"edb_dap_request_stack_trace.html#t:arguments/0"},{"type":"type","title":"edb_dap_request_stack_trace.response_body/0","doc":null,"ref":"edb_dap_request_stack_trace.html#t:response_body/0"},{"type":"type","title":"edb_dap_request_stack_trace.stack_frame/0","doc":null,"ref":"edb_dap_request_stack_trace.html#t:stack_frame/0"},{"type":"type","title":"edb_dap_request_stack_trace.stack_frame_format/0","doc":null,"ref":"edb_dap_request_stack_trace.html#t:stack_frame_format/0"},{"type":"module","title":"edb_dap_request_step_in","doc":null,"ref":"edb_dap_request_step_in.html"},{"type":"function","title":"edb_dap_request_step_in.handle/2","doc":null,"ref":"edb_dap_request_step_in.html#handle/2"},{"type":"function","title":"edb_dap_request_step_in.parse_arguments/1","doc":null,"ref":"edb_dap_request_step_in.html#parse_arguments/1"},{"type":"function","title":"edb_dap_request_step_in.react_to_call_target_error/1","doc":null,"ref":"edb_dap_request_step_in.html#react_to_call_target_error/1"},{"type":"type","title":"edb_dap_request_step_in.arguments/0","doc":null,"ref":"edb_dap_request_step_in.html#t:arguments/0"},{"type":"module","title":"edb_dap_request_step_out","doc":null,"ref":"edb_dap_request_step_out.html"},{"type":"function","title":"edb_dap_request_step_out.handle/2","doc":null,"ref":"edb_dap_request_step_out.html#handle/2"},{"type":"function","title":"edb_dap_request_step_out.parse_arguments/1","doc":null,"ref":"edb_dap_request_step_out.html#parse_arguments/1"},{"type":"type","title":"edb_dap_request_step_out.arguments/0","doc":null,"ref":"edb_dap_request_step_out.html#t:arguments/0"},{"type":"module","title":"edb_dap_request_threads","doc":null,"ref":"edb_dap_request_threads.html"},{"type":"function","title":"edb_dap_request_threads.handle/2","doc":null,"ref":"edb_dap_request_threads.html#handle/2"},{"type":"function","title":"edb_dap_request_threads.parse_arguments/1","doc":null,"ref":"edb_dap_request_threads.html#parse_arguments/1"},{"type":"type","title":"edb_dap_request_threads.arguments/0","doc":null,"ref":"edb_dap_request_threads.html#t:arguments/0"},{"type":"type","title":"edb_dap_request_threads.thread/0","doc":null,"ref":"edb_dap_request_threads.html#t:thread/0"},{"type":"type","title":"edb_dap_request_threads.threads/0","doc":null,"ref":"edb_dap_request_threads.html#t:threads/0"},{"type":"module","title":"edb_dap_request_variables","doc":null,"ref":"edb_dap_request_variables.html"},{"type":"function","title":"edb_dap_request_variables.handle/2","doc":null,"ref":"edb_dap_request_variables.html#handle/2"},{"type":"function","title":"edb_dap_request_variables.parse_arguments/1","doc":null,"ref":"edb_dap_request_variables.html#parse_arguments/1"},{"type":"type","title":"edb_dap_request_variables.arguments/0","doc":null,"ref":"edb_dap_request_variables.html#t:arguments/0"},{"type":"type","title":"edb_dap_request_variables.response_body/0","doc":null,"ref":"edb_dap_request_variables.html#t:response_body/0"},{"type":"type","title":"edb_dap_request_variables.value_format/0","doc":null,"ref":"edb_dap_request_variables.html#t:value_format/0"},{"type":"type","title":"edb_dap_request_variables.variable/0","doc":null,"ref":"edb_dap_request_variables.html#t:variable/0"},{"type":"type","title":"edb_dap_request_variables.variable_presentation_hint/0","doc":null,"ref":"edb_dap_request_variables.html#t:variable_presentation_hint/0"},{"type":"behaviour","title":"edb_dap_reverse_request","doc":"Behaviour for handling reverse-requests to the client","ref":"edb_dap_reverse_request.html"},{"type":"function","title":"edb_dap_reverse_request.dispatch_response/2","doc":"","ref":"edb_dap_reverse_request.html#dispatch_response/2"},{"type":"callback","title":"edb_dap_reverse_request.handle_response/2","doc":"","ref":"edb_dap_reverse_request.html#c:handle_response/2"},{"type":"callback","title":"edb_dap_reverse_request.make_request/1","doc":"","ref":"edb_dap_reverse_request.html#c:make_request/1"},{"type":"function","title":"edb_dap_reverse_request.unexpected_response/0","doc":"","ref":"edb_dap_reverse_request.html#unexpected_response/0"},{"type":"type","title":"edb_dap_reverse_request.reaction/0","doc":"","ref":"edb_dap_reverse_request.html#t:reaction/0"},{"type":"type","title":"edb_dap_reverse_request.request/0","doc":"","ref":"edb_dap_reverse_request.html#t:request/0"},{"type":"type","title":"edb_dap_reverse_request.request/1","doc":"","ref":"edb_dap_reverse_request.html#t:request/1"},{"type":"module","title":"edb_dap_reverse_request_run_in_terminal","doc":null,"ref":"edb_dap_reverse_request_run_in_terminal.html"},{"type":"function","title":"edb_dap_reverse_request_run_in_terminal.handle_response/2","doc":null,"ref":"edb_dap_reverse_request_run_in_terminal.html#handle_response/2"},{"type":"function","title":"edb_dap_reverse_request_run_in_terminal.make_request/1","doc":null,"ref":"edb_dap_reverse_request_run_in_terminal.html#make_request/1"},{"type":"type","title":"edb_dap_reverse_request_run_in_terminal.arguments/0","doc":null,"ref":"edb_dap_reverse_request_run_in_terminal.html#t:arguments/0"},{"type":"type","title":"edb_dap_reverse_request_run_in_terminal.response_body/0","doc":null,"ref":"edb_dap_reverse_request_run_in_terminal.html#t:response_body/0"},{"type":"module","title":"edb_dap_server","doc":"Handling of DAP requests, responses and events\n\nFor details see https://microsoft.github.io/debug-adapter-protocol/specification","ref":"edb_dap_server.html"},{"type":"function","title":"edb_dap_server.handle_call/3","doc":"","ref":"edb_dap_server.html#handle_call/3"},{"type":"function","title":"edb_dap_server.handle_cast/2","doc":"","ref":"edb_dap_server.html#handle_cast/2"},{"type":"function","title":"edb_dap_server.handle_info/2","doc":"","ref":"edb_dap_server.html#handle_info/2"},{"type":"function","title":"edb_dap_server.handle_message/1","doc":"","ref":"edb_dap_server.html#handle_message/1"},{"type":"function","title":"edb_dap_server.init/1","doc":"","ref":"edb_dap_server.html#init/1"},{"type":"function","title":"edb_dap_server.start_link/0","doc":"","ref":"edb_dap_server.html#start_link/0"},{"type":"function","title":"edb_dap_server.terminate/2","doc":"","ref":"edb_dap_server.html#terminate/2"},{"type":"type","title":"edb_dap_server.action/0","doc":"","ref":"edb_dap_server.html#t:action/0"},{"type":"type","title":"edb_dap_server.attach_type/0","doc":"","ref":"edb_dap_server.html#t:attach_type/0"},{"type":"type","title":"edb_dap_server.cast_request/0","doc":"","ref":"edb_dap_server.html#t:cast_request/0"},{"type":"type","title":"edb_dap_server.client_info/0","doc":"","ref":"edb_dap_server.html#t:client_info/0"},{"type":"type","title":"edb_dap_server.error/0","doc":"","ref":"edb_dap_server.html#t:error/0"},{"type":"type","title":"edb_dap_server.state/0","doc":"","ref":"edb_dap_server.html#t:state/0"},{"type":"module","title":"edb_dap_transport","doc":"Transport layer of the DAP server\nThis module deals with serialization/deserialization, sequencing\nand other low-level details of the DAP frontend for the edb Erlang\ndebugger.\n\nFor the actual handling of requests, etc. see the edb_dap_server\nmodule.","ref":"edb_dap_transport.html"},{"type":"function","title":"edb_dap_transport.handle_call/3","doc":"","ref":"edb_dap_transport.html#handle_call/3"},{"type":"function","title":"edb_dap_transport.handle_cast/2","doc":"","ref":"edb_dap_transport.html#handle_cast/2"},{"type":"function","title":"edb_dap_transport.handle_info/2","doc":"","ref":"edb_dap_transport.html#handle_info/2"},{"type":"function","title":"edb_dap_transport.init/1","doc":"","ref":"edb_dap_transport.html#init/1"},{"type":"function","title":"edb_dap_transport.send_event/1","doc":"","ref":"edb_dap_transport.html#send_event/1"},{"type":"function","title":"edb_dap_transport.send_response/2","doc":"","ref":"edb_dap_transport.html#send_response/2"},{"type":"function","title":"edb_dap_transport.send_reverse_request/1","doc":"","ref":"edb_dap_transport.html#send_reverse_request/1"},{"type":"function","title":"edb_dap_transport.start_link/0","doc":"","ref":"edb_dap_transport.html#start_link/0"},{"type":"function","title":"edb_dap_transport.terminate/2","doc":"","ref":"edb_dap_transport.html#terminate/2"},{"type":"type","title":"edb_dap_transport.action/0","doc":"","ref":"edb_dap_transport.html#t:action/0"},{"type":"type","title":"edb_dap_transport.state/0","doc":"","ref":"edb_dap_transport.html#t:state/0"},{"type":"module","title":"edb_dap_utils","doc":"DAP Request Handlers\nThe actual implementation for the DAP requests.\nThis function should be invoked by the DAP server.","ref":"edb_dap_utils.html"},{"type":"function","title":"edb_dap_utils.strip_suffix/2","doc":"","ref":"edb_dap_utils.html#strip_suffix/2"},{"type":"module","title":"edb_main","doc":null,"ref":"edb_main.html"},{"type":"function","title":"edb_main.main/1","doc":null,"ref":"edb_main.html#main/1"},{"type":"module","title":"edb_sup","doc":"edb top level supervisor.","ref":"edb_sup.html"},{"type":"function","title":"edb_sup.init/1","doc":"","ref":"edb_sup.html#init/1"},{"type":"function","title":"edb_sup.start_link/0","doc":"","ref":"edb_sup.html#start_link/0"},{"type":"extras","title":"edb","doc":"# edb\n\nThe next-generation debugger for Erlang.","ref":"readme.html"},{"type":"extras","title":"Prerequisites - edb","doc":"`edb` currently requires a modified version of Erlang/OTP which, for convenience,\nis checked in as a git submodule, until all require changes will make it upstream.\n\nYou can build and install the modified version of Erlang/OTP by doing:\n\n    $ git submodule update --init\n    $ pushd otp\n    $ ./configure --prefix $(pwd)/../otp-bin\n    $ make -j$(nproc)\n    $ make -j$(nproc) install\n    $ popd\n\n**Note:** on Mac you may need to provide a custom installation path\nfor OpenSSl. Just replace the above configuration step with:\n\n    $ ./configure --prefix $(pwd)/../otp-bin --with-ssl=$(brew --prefix openssl)\n\nThen simply add the installation dir to your `$PATH`:\n\n    $ export PATH=$(pwd)/otp-bin/bin:$PATH\n\nVerify the Erlang installation:\n\n    $ which erl # Should point to the newly built version of Erlang/OTP\n\nYou will also need a version of `rebar3` built with Erlang/OTP 26 or higher.\nYou can find instructions on how to build `rebar3` from source [here](https://rebar3.org/docs/getting-started/#installing-from-source).","ref":"readme.html#prerequisites"},{"type":"extras","title":"Get EDB - edb","doc":"You can either download a pre-built version of the EDB debugger or build it from source.","ref":"readme.html#get-edb"},{"type":"extras","title":"Download - edb","doc":"You can visit the [Releases](https://github.com/WhatsApp/edb/releases) page for EDB and download a pre-built version of EDB.\n\nYou can also download an EDB version for a specific commit by visiting the [Commits History page](https://github.com/WhatsApp/edb/commits/main/), click on the \"green tick\" next to a given commit, click on \"details\" for the CI job, check the \"Summary\". You will find the pre-built versions among the \"artifacts\" for the commit.","ref":"readme.html#download"},{"type":"extras","title":"Build from source - edb","doc":"A pre-built version of EDB for your OS/architecture may not be available. In that case you can build one from source. Remember to check the [Prerequisites](./prerequisites.md) sections for details.\n\n    $ git clone https://github.com/WhatsApp/edb.git\n    $ cd edb\n    $ rebar3 escriptize\n\nThe produced `edb` escript will be available in:\n\n    _build/default/bin/edb","ref":"readme.html#build-from-source"},{"type":"extras","title":"Usage - edb","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Start the DAP adapter for `edb` - edb","doc":"$ _build/default/bin/edb dap\n\nThis is the command that you tipically want your IDE (VS Code, Emacs) to trigger.","ref":"readme.html#start-the-dap-adapter-for-edb"},{"type":"extras","title":"Configure a rebar3 project - edb","doc":"Before we can debug a [rebar3](https://rebar3.org/) project with EDB, we need to ensure that we build the code using the `beam_debug_info` option.\n\nSince we want to only use the debugger to debug test and we don't want to affect production, these changes can be limited to the `test` profile.\n\nOpen the `rebar.config` file for the project and ensure the `beam_debug_info` option is included as part of `erl_opts`.\n\n```\n{profiles, [\n    {test, [\n        {erl_opts, [debug_info, beam_debug_info]}\n    ]}\n]}.\n```","ref":"readme.html#configure-a-rebar3-project"},{"type":"extras","title":"Troubleshooting - edb","doc":"","ref":"readme.html#troubleshooting"},{"type":"extras","title":"DAP Logs - edb","doc":"When started EDB as a DAP debugger, EDB logs useful information that can help you understanding whether EDB is communicating correctly with a client (tipically, the IDE).\n\nTo find the location of the EDB DAP logs on your machine, open an Erlang shell and run:\n\n```\n$ erl\n\nErlang/OTP [...]\n\nEshell [...] (press Ctrl+G to abort, type help(). for help)\n1> filename:basedir(user_log, \"edb\").\n```\n\nThat will return the path where you will find a `edb.log` file.","ref":"readme.html#dap-logs"},{"type":"extras","title":"License - edb","doc":"EDB is Apache 2.0 licensed, as found in the [LICENSE.md](./LICENSE.md) file.","ref":"readme.html#license"},{"type":"extras","title":"Apache License","doc":"# Apache License\nVersion 2.0, January 2004\n\nhttp://www.apache.org/licenses/\n\nTERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION","ref":"license.html"},{"type":"extras","title":"1. Definitions. - Apache License","doc":"\"License\" shall mean the terms and conditions for use, reproduction, and\ndistribution as defined by Sections 1 through 9 of this document.\n\n\"Licensor\" shall mean the copyright owner or entity authorized by the copyright\nowner that is granting the License.\n\n\"Legal Entity\" shall mean the union of the acting entity and all other entities\nthat control, are controlled by, or are under common control with that entity.\nFor the purposes of this definition, \"control\" means (i) the power, direct or\nindirect, to cause the direction or management of such entity, whether by\ncontract or otherwise, or (ii) ownership of fifty percent (50%) or more of the\noutstanding shares, or (iii) beneficial ownership of such entity.\n\n\"You\" (or \"Your\") shall mean an individual or Legal Entity exercising\npermissions granted by this License.\n\n\"Source\" form shall mean the preferred form for making modifications, including\nbut not limited to software source code, documentation source, and configuration\nfiles.\n\n\"Object\" form shall mean any form resulting from mechanical transformation or\ntranslation of a Source form, including but not limited to compiled object code,\ngenerated documentation, and conversions to other media types.\n\n\"Work\" shall mean the work of authorship, whether in Source or Object form, made\navailable under the License, as indicated by a copyright notice that is included\nin or attached to the work (an example is provided in the Appendix below).\n\n\"Derivative Works\" shall mean any work, whether in Source or Object form, that\nis based on (or derived from) the Work and for which the editorial revisions,\nannotations, elaborations, or other modifications represent, as a whole, an\noriginal work of authorship. For the purposes of this License, Derivative Works\nshall not include works that remain separable from, or merely link (or bind by\nname) to the interfaces of, the Work and Derivative Works thereof.\n\n\"Contribution\" shall mean any work of authorship, including the original version\nof the Work and any modifications or additions to that Work or Derivative Works\nthereof, that is intentionally submitted to Licensor for inclusion in the Work\nby the copyright owner or by an individual or Legal Entity authorized to submit\non behalf of the copyright owner. For the purposes of this definition,\n\"submitted\" means any form of electronic, verbal, or written communication sent\nto the Licensor or its representatives, including but not limited to\ncommunication on electronic mailing lists, source code control systems, and\nissue tracking systems that are managed by, or on behalf of, the Licensor for\nthe purpose of discussing and improving the Work, but excluding communication\nthat is conspicuously marked or otherwise designated in writing by the copyright\nowner as \"Not a Contribution.\"\n\n\"Contributor\" shall mean Licensor and any individual or Legal Entity on behalf\nof whom a Contribution has been received by Licensor and subsequently\nincorporated within the Work.","ref":"license.html#1-definitions"},{"type":"extras","title":"2. Grant of Copyright License. - Apache License","doc":"Subject to the terms and conditions of this License, each Contributor hereby\ngrants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free,\nirrevocable copyright license to reproduce, prepare Derivative Works of,\npublicly display, publicly perform, sublicense, and distribute the Work and such\nDerivative Works in Source or Object form.","ref":"license.html#2-grant-of-copyright-license"},{"type":"extras","title":"3. Grant of Patent License. - Apache License","doc":"Subject to the terms and conditions of this License, each Contributor hereby\ngrants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free,\nirrevocable (except as stated in this section) patent license to make, have\nmade, use, offer to sell, sell, import, and otherwise transfer the Work, where\nsuch license applies only to those patent claims licensable by such Contributor\nthat are necessarily infringed by their Contribution(s) alone or by combination\nof their Contribution(s) with the Work to which such Contribution(s) was\nsubmitted. If You institute patent litigation against any entity (including a\ncross-claim or counterclaim in a lawsuit) alleging that the Work or a\nContribution incorporated within the Work constitutes direct or contributory\npatent infringement, then any patent licenses granted to You under this License\nfor that Work shall terminate as of the date such litigation is filed.","ref":"license.html#3-grant-of-patent-license"},{"type":"extras","title":"4. Redistribution. - Apache License","doc":"You may reproduce and distribute copies of the Work or Derivative Works thereof\nin any medium, with or without modifications, and in Source or Object form,\nprovided that You meet the following conditions:\n\n1. You must give any other recipients of the Work or Derivative Works a copy of\n   this License; and\n\n2. You must cause any modified files to carry prominent notices stating that\n   You changed the files; and\n\n3. You must retain, in the Source form of any Derivative Works that You\n   distribute, all copyright, patent, trademark, and attribution notices from\n   the Source form of the Work, excluding those notices that do not pertain to\n   any part of the Derivative Works; and\n\n4. If the Work includes a \"NOTICE\" text file as part of its distribution, then\n   any Derivative Works that You distribute must include a readable copy of the\n   attribution notices contained within such NOTICE file, excluding those\n   notices that do not pertain to any part of the Derivative Works, in at least\n   one of the following places: within a NOTICE text file distributed as part\n   of the Derivative Works; within the Source form or documentation, if\n   provided along with the Derivative Works; or, within a display generated by\n   the Derivative Works, if and wherever such third-party notices normally\n   appear. The contents of the NOTICE file are for informational purposes only\n   and do not modify the License. You may add Your own attribution notices\n   within Derivative Works that You distribute, alongside or as an addendum to\n   the NOTICE text from the Work, provided that such additional attribution\n   notices cannot be construed as modifying the License.\n\nYou may add Your own copyright statement to Your modifications and may provide\nadditional or different license terms and conditions for use, reproduction, or\ndistribution of Your modifications, or for any such Derivative Works as a whole,\nprovided Your use, reproduction, and distribution of the Work otherwise complies\nwith the conditions stated in this License.","ref":"license.html#4-redistribution"},{"type":"extras","title":"5. Submission of Contributions. - Apache License","doc":"Unless You explicitly state otherwise, any Contribution intentionally submitted\nfor inclusion in the Work by You to the Licensor shall be under the terms and\nconditions of this License, without any additional terms or conditions.\nNotwithstanding the above, nothing herein shall supersede or modify the terms of\nany separate license agreement you may have executed with Licensor regarding\nsuch Contributions.","ref":"license.html#5-submission-of-contributions"},{"type":"extras","title":"6. Trademarks. - Apache License","doc":"This License does not grant permission to use the trade names, trademarks,\nservice marks, or product names of the Licensor, except as required for\nreasonable and customary use in describing the origin of the Work and\nreproducing the content of the NOTICE file.","ref":"license.html#6-trademarks"},{"type":"extras","title":"7. Disclaimer of Warranty. - Apache License","doc":"Unless required by applicable law or agreed to in writing, Licensor provides the\nWork (and each Contributor provides its Contributions) on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied,\nincluding, without limitation, any warranties or conditions of TITLE, NON-\nINFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are\nsolely responsible for determining the appropriateness of using or\nredistributing the Work and assume any risks associated with Your exercise of\npermissions under this License.","ref":"license.html#7-disclaimer-of-warranty"},{"type":"extras","title":"8. Limitation of Liability. - Apache License","doc":"In no event and under no legal theory, whether in tort (including negligence),\ncontract, or otherwise, unless required by applicable law (such as deliberate\nand grossly negligent acts) or agreed to in writing, shall any Contributor be\nliable to You for damages, including any direct, indirect, special, incidental,\nor consequential damages of any character arising as a result of this License or\nout of the use or inability to use the Work (including but not limited to\ndamages for loss of goodwill, work stoppage, computer failure or malfunction, or\nany and all other commercial damages or losses), even if such Contributor has\nbeen advised of the possibility of such damages.","ref":"license.html#8-limitation-of-liability"},{"type":"extras","title":"9. Accepting Warranty or Additional Liability. - Apache License","doc":"While redistributing the Work or Derivative Works thereof, You may choose to\noffer, and charge a fee for, acceptance of support, warranty, indemnity, or\nother liability obligations and/or rights consistent with this License. However,\nin accepting such obligations, You may act only on Your own behalf and on Your\nsole responsibility, not on behalf of any other Contributor, and only if You\nagree to indemnify, defend, and hold each Contributor harmless for any liability\nincurred by, or claims asserted against, such Contributor by reason of your\naccepting any such warranty or additional liability.\n\nEND OF TERMS AND CONDITIONS\n\nAPPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright [yyyy] [name of copyright owner]\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html#9-accepting-warranty-or-additional-liability"}],"proglang":"erlang","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}